//                    in the name of god

//#define LANDSCAPE
#define PORTRAIT


#ifndef CONFIG_Glcd_320240_H
#define CONFIG_Glcd_320240_H

#include <avr/io.h>

#define LCD_RST_DDR    PORTD_DIR
#define LCD_RST_PORT   PORTD_OUT
#define LCD_RST_PIN    0

#define LCD_RS_DDR     PORTD_DIR
#define LCD_RS_PORT    PORTD_OUT
#define LCD_RS_PIN     1

#define LCD_CS_DDR     PORTD_DIR
#define LCD_CS_PORT    PORTD_OUT
#define LCD_CS_PIN     2

#define LCD_RD_DDR     PORTD_DIR
#define LCD_RD_PORT    PORTD_OUT
#define LCD_RD_PIN     3

#define LCD_WR_DDR     PORTD_DIR
#define LCD_WR_PORT    PORTD_OUT
#define LCD_WR_PIN     4

#define LCD_DATAPORT_MSB_DDR        PORTH_DIR
#define LCD_DATAPORT_MSB_PORT       PORTH_OUT
#define LCD_DATAPORT_MSB_PIN        PORTH_IN

#define LCD_DATAPORT_LSB_DDR        PORTJ_DIR
#define LCD_DATAPORT_LSB_PORT       PORTJ_OUT
#define LCD_DATAPORT_LSB_PIN        PORTJ_IN
                                   
#define LCD_CONTROLPORT_DDR         PORTD_DIR
#define LCD_CONTROLPORT_PORT        PORTD_OUT
#define LCD_CONTROLPORT_PIN         PORTD_IN

#define SBI(IOPORT,BIT)  IOPORT |=(1<<BIT)
#define CBI(IOPORT,BIT)  IOPORT &=~(1<<BIT)

#define HIGH 1
#define LOW  0

#define RST_LOW       CBI(LCD_CONTROLPORT_PORT,LCD_RST_PIN)
#define RST_HIGH      SBI(LCD_CONTROLPORT_PORT,LCD_RST_PIN)
#define RS_LOW        CBI(LCD_CONTROLPORT_PORT,LCD_RS_PIN)
#define RS_HIGH       SBI(LCD_CONTROLPORT_PORT,LCD_RS_PIN)
#define CS_LOW        CBI(LCD_CONTROLPORT_PORT,LCD_CS_PIN)
#define CS_HIGH       SBI(LCD_CONTROLPORT_PORT,LCD_CS_PIN)
#define RD_LOW        CBI(LCD_CONTROLPORT_PORT,LCD_RD_PIN)
#define RD_HIGH       SBI(LCD_CONTROLPORT_PORT,LCD_RD_PIN)
#define WR_LOW        CBI(LCD_CONTROLPORT_PORT,LCD_WR_PIN)
#define WR_HIGH       SBI(LCD_CONTROLPORT_PORT,LCD_WR_PIN)

#define LCD_DATAPORT_INPUT          LCD_DATAPORT_MSB_DDR=0x00;LCD_DATAPORT_LSB_DDR=0x00
#define LCD_DATAPORT_OUTPUT         LCD_DATAPORT_MSB_DDR=0xFF;LCD_DATAPORT_LSB_DDR=0xFF
#define LCD_DATAPORT_CLEAR          LCD_DATAPORT_MSB_PORT=0x00;LCD_DATAPORT_LSB_PORT=0x00

#define TS_INS_START_OSC          0x00
#define TS_INS_DRIV_OUT_CTRL        0x01
#define TS_INS_DRIV_WAV_CTRL        0x02
#define TS_INS_ENTRY_MOD            0x03
#define TS_INS_RESIZE_CTRL            0x04
#define TS_INS_DISP_CTRL1            0x07
#define TS_INS_DISP_CTRL2            0x08
#define TS_INS_DISP_CTRL3            0x09
#define TS_INS_DISP_CTRL4            0x0A
#define TS_INS_RGB_DISP_IF_CTRL1    0x0C
#define TS_INS_FRM_MARKER_POS        0x0D
#define TS_INS_RGB_DISP_IF_CTRL2    0x0F
#define TS_INS_POW_CTRL1            0x10
#define TS_INS_POW_CTRL2            0x11
#define TS_INS_POW_CTRL3            0x12
#define TS_INS_POW_CTRL4            0x13
#define TS_INS_GRAM_HOR_AD            0x20
#define TS_INS_GRAM_VER_AD            0x21
#define TS_INS_RW_GRAM                0x22
#define TS_INS_POW_CTRL7            0x29
#define TS_INS_FRM_RATE_COL_CTRL    0x2B
#define TS_INS_GAMMA_CTRL1            0x30
#define TS_INS_GAMMA_CTRL2            0x31
#define TS_INS_GAMMA_CTRL3            0x32
#define TS_INS_GAMMA_CTRL4            0x35 
#define TS_INS_GAMMA_CTRL5            0x36
#define TS_INS_GAMMA_CTRL6            0x37
#define TS_INS_GAMMA_CTRL7            0x38
#define TS_INS_GAMMA_CTRL8            0x39
#define TS_INS_GAMMA_CTRL9            0x3C
#define TS_INS_GAMMA_CTRL10            0x3D
#define TS_INS_HOR_START_AD            0x50
#define TS_INS_HOR_END_AD            0x51
#define TS_INS_VER_START_AD            0x52
#define TS_INS_VER_END_AD            0x53
#define TS_INS_GATE_SCAN_CTRL1        0x60
#define TS_INS_GATE_SCAN_CTRL2        0x61
#define TS_INS_GATE_SCAN_CTRL3        0x6A
#define TS_INS_PART_IMG1_DISP_POS    0x80
#define TS_INS_PART_IMG1_START_AD    0x81
#define TS_INS_PART_IMG1_END_AD        0x82
#define TS_INS_PART_IMG2_DISP_POS    0x83
#define TS_INS_PART_IMG2_START_AD    0x84
#define TS_INS_PART_IMG2_END_AD        0x85
#define TS_INS_PANEL_IF_CTRL1        0x90
#define TS_INS_PANEL_IF_CTRL2        0x92
#define TS_INS_PANEL_IF_CTRL3        0x93
#define TS_INS_PANEL_IF_CTRL4        0x95
#define TS_INS_PANEL_IF_CTRL5        0x97
#define TS_INS_PANEL_IF_CTRL6        0x98           

#ifdef PORTRAIT
#define TS_SIZE_X                    240
#define TS_SIZE_Y                    320
#define TS_VAL_ENTRY_MOD             0x0030
#define TS_INS_GRAM_ADX              TS_INS_GRAM_HOR_AD
#define TS_INS_GRAM_ADY              TS_INS_GRAM_VER_AD
#define TS_INS_START_ADX             TS_INS_HOR_START_AD
#define TS_INS_END_ADX               TS_INS_HOR_END_AD
#define TS_INS_START_ADY             TS_INS_VER_START_AD
#define TS_INS_END_ADY               TS_INS_VER_END_AD
#endif

#ifdef LANDSCAPE
#define TS_SIZE_X					320
#define TS_SIZE_Y					240
#define TS_VAL_ENTRY_MOD			0x0028
#define TS_INS_GRAM_ADX				TS_INS_GRAM_VER_AD
#define TS_INS_GRAM_ADY				TS_INS_GRAM_HOR_AD
#define TS_INS_START_ADX   			TS_INS_VER_START_AD
#define TS_INS_END_ADX   			TS_INS_VER_END_AD
#define TS_INS_START_ADY   			TS_INS_HOR_START_AD
#define TS_INS_END_ADY   			TS_INS_HOR_END_AD
#endif


#define RED                    0x001F
#define GREEN                0x07E0
#define BLUE                0xF800
#define YELLOW                0x07FF
#define PURPLE                0xF81F
#define BLACK                0x0000
#define WHITE                0xFFFF

#endif	/*CONFIG_Glcd_320240_H*/

